
<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta charset="utf-8" />
    <title>Quickstart &#8212; pyroute2 0.5.14 documentation</title>
    <link rel="stylesheet" href="_static/classic.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    <link rel="stylesheet" type="text/css" href="_static/graphviz.css" />
    <link rel="stylesheet" type="text/css" href="_static/custom.css" />
    
    <script type="text/javascript" id="documentation_options" data-url_root="./" src="_static/documentation_options.js"></script>
    <script type="text/javascript" src="_static/jquery.js"></script>
    <script type="text/javascript" src="_static/underscore.js"></script>
    <script type="text/javascript" src="_static/doctools.js"></script>
    <script type="text/javascript" src="_static/language_data.js"></script>
    
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="IPRoute module" href="iproute.html" />
    <link rel="prev" title="Report a bug" href="report.html" />
<!-- Global site tag (gtag.js) - Google Analytics -->
<script async src="https://www.googletagmanager.com/gtag/js?id=UA-121787797-2"></script>
<script>
  window.dataLayer = window.dataLayer || [];
  function gtag(){dataLayer.push(arguments);}
  gtag('js', new Date());

  gtag('config', 'UA-121787797-2');
</script>
 

  </head><body>

    <div class="related" role="navigation" aria-label="related navigation">
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="iproute.html" title="IPRoute module"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="report.html" title="Report a bug"
             accesskey="P">previous</a> |</li>
        <li class="nav-item"><a href="http://pyroute2.org">Project home</a> &#187;</li>
        <li class="nav-item nav-item-0"><a href="index.html">pyroute2 0.5.14 documentation</a> &#187;</li> 
      </ul>
        </div>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="quickstart">
<h1>Quickstart<a class="headerlink" href="#quickstart" title="Permalink to this headline">¶</a></h1>
<p>Hello, world:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>$ sudo pip install pyroute2

$ cat example.py
from pyroute2 import IPRoute
with IPRoute() as ipr:
    print([x.get_attr(&#39;IFLA_IFNAME&#39;) for x in ipr.get_links()])

$ python example.py
[&#39;lo&#39;, &#39;p6p1&#39;, &#39;wlan0&#39;, &#39;virbr0&#39;, &#39;virbr0-nic&#39;]
</pre></div>
</div>
<div class="section" id="sockets">
<h2>Sockets<a class="headerlink" href="#sockets" title="Permalink to this headline">¶</a></h2>
<p>In the runtime pyroute2 socket objects behave as normal
sockets. One can use them in the poll/select, one can
call <cite>recv()</cite> and <cite>sendmsg()</cite>:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">pyroute2</span> <span class="k">import</span> <span class="n">IPRoute</span>

<span class="c1"># create RTNL socket</span>
<span class="n">ipr</span> <span class="o">=</span> <span class="n">IPRoute</span><span class="p">()</span>

<span class="c1"># subscribe to broadcast messages</span>
<span class="n">ipr</span><span class="o">.</span><span class="n">bind</span><span class="p">()</span>

<span class="c1"># wait for data (do not parse it)</span>
<span class="n">data</span> <span class="o">=</span> <span class="n">ipr</span><span class="o">.</span><span class="n">recv</span><span class="p">(</span><span class="mi">65535</span><span class="p">)</span>

<span class="c1"># parse received data</span>
<span class="n">messages</span> <span class="o">=</span> <span class="n">ipr</span><span class="o">.</span><span class="n">marshal</span><span class="o">.</span><span class="n">parse</span><span class="p">(</span><span class="n">data</span><span class="p">)</span>

<span class="c1"># shortcut: recv() + parse()</span>
<span class="c1">#</span>
<span class="c1"># (under the hood is much more, but for</span>
<span class="c1"># simplicity it&#39;s enough to say so)</span>
<span class="c1">#</span>
<span class="n">messages</span> <span class="o">=</span> <span class="n">ipr</span><span class="o">.</span><span class="n">get</span><span class="p">()</span>
</pre></div>
</div>
<p>But pyroute2 objects have a lot of methods, written to
handle specific tasks:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">pyroute2</span> <span class="k">import</span> <span class="n">IPRoute</span>

<span class="c1"># RTNL interface</span>
<span class="k">with</span> <span class="n">IPRoute</span><span class="p">()</span> <span class="k">as</span> <span class="n">ipr</span><span class="p">:</span>

    <span class="c1"># get devices list</span>
    <span class="n">ipr</span><span class="o">.</span><span class="n">get_links</span><span class="p">()</span>

    <span class="c1"># get addresses</span>
    <span class="n">ipr</span><span class="o">.</span><span class="n">get_addr</span><span class="p">()</span>
</pre></div>
</div>
</div>
<div class="section" id="resource-release">
<h2>Resource release<a class="headerlink" href="#resource-release" title="Permalink to this headline">¶</a></h2>
<p>Do not forget to release resources and close sockets. Also
keep in mind, that the real fd will be closed only when the
Python GC will collect closed objects.</p>
</div>
<div class="section" id="imports">
<h2>Imports<a class="headerlink" href="#imports" title="Permalink to this headline">¶</a></h2>
<p>The public API is exported by <cite>pyroute2/__init__.py</cite>.</p>
<p>It is done so to provide a stable API that will not be affected
by changes in the package layout. There may be significant
layout changes between versions, but if a symbol is re-exported
via <cite>pyroute2/__init__.py</cite>, it will be available with the same
import signature.</p>
<div class="admonition warning">
<p class="admonition-title">Warning</p>
<p>All other objects are also available for import, but they
may change signatures in the next versions.</p>
</div>
<p>E.g.:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="c1"># Import a pyroute2 class directly. In the next versions</span>
<span class="c1"># the import signature can be changed, e.g., NetNS from</span>
<span class="c1"># pyroute2.netns.nslink it can be moved somewhere else.</span>
<span class="c1">#</span>
<span class="kn">from</span> <span class="nn">pyroute2.netns.nslink</span> <span class="k">import</span> <span class="n">NetNS</span>
<span class="n">ns</span> <span class="o">=</span> <span class="n">NetNS</span><span class="p">(</span><span class="s1">&#39;test&#39;</span><span class="p">)</span>

<span class="c1"># Import the same class from root module. This signature</span>
<span class="c1"># will stay the same, any layout change is reflected in</span>
<span class="c1"># the root module.</span>
<span class="c1">#</span>
<span class="kn">from</span> <span class="nn">pyroute2</span> <span class="k">import</span> <span class="n">NetNS</span>
<span class="n">ns</span> <span class="o">=</span> <span class="n">NetNS</span><span class="p">(</span><span class="s1">&#39;test&#39;</span><span class="p">)</span>
</pre></div>
</div>
</div>
</div>
<div class="section" id="special-cases">
<h1>Special cases<a class="headerlink" href="#special-cases" title="Permalink to this headline">¶</a></h1>
<div class="section" id="eventlet">
<h2>eventlet<a class="headerlink" href="#eventlet" title="Permalink to this headline">¶</a></h2>
<p>The eventlet environment conflicts in some way with socket
objects, and pyroute2 provides some workaround for that:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="c1"># import symbols</span>
<span class="c1">#</span>
<span class="kn">import</span> <span class="nn">eventlet</span>
<span class="kn">from</span> <span class="nn">pyroute2</span> <span class="k">import</span> <span class="n">NetNS</span>
<span class="kn">from</span> <span class="nn">pyroute2.config.eventlet</span> <span class="k">import</span> <span class="n">eventlet_config</span>

<span class="c1"># setup the environment</span>
<span class="n">eventlet</span><span class="o">.</span><span class="n">monkey_patch</span><span class="p">()</span>
<span class="n">eventlet_config</span><span class="p">()</span>

<span class="c1"># run the code</span>
<span class="n">ns</span> <span class="o">=</span> <span class="n">NetNS</span><span class="p">(</span><span class="s1">&#39;nsname&#39;</span><span class="p">)</span>
<span class="n">ns</span><span class="o">.</span><span class="n">get_routes</span><span class="p">()</span>
<span class="o">...</span>
</pre></div>
</div>
<p>This may help, but not always. In general, the pyroute2 library
is not eventlet-friendly.</p>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">Quickstart</a><ul>
<li><a class="reference internal" href="#sockets">Sockets</a></li>
<li><a class="reference internal" href="#resource-release">Resource release</a></li>
<li><a class="reference internal" href="#imports">Imports</a></li>
</ul>
</li>
<li><a class="reference internal" href="#special-cases">Special cases</a><ul>
<li><a class="reference internal" href="#eventlet">eventlet</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="report.html"
                        title="previous chapter">Report a bug</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="iproute.html"
                        title="next chapter">IPRoute module</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="_sources/usage.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="iproute.html" title="IPRoute module"
             >next</a> |</li>
        <li class="right" >
          <a href="report.html" title="Report a bug"
             >previous</a> |</li>
        <li class="nav-item"><a href="http://pyroute2.org">Project home</a> &#187;</li>
        <li class="nav-item nav-item-0"><a href="index.html">pyroute2 0.5.14 documentation</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2013, Peter V. Saveliev.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 2.1.2.
    </div>
  </body>
</html>